import java.awt.Color;
import java.awt.Graphics;
import java.awt.Point;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.util.ArrayList;

import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JTextField;

public class Gerador extends JFrame implements MouseListener, ActionListener {

	private static final long serialVersionUID = 1L;
	int posX;
	int posY;
	int larguraQuadro = 600;
	int alturaQuadro = 600;
	int larguraAgente = 10;
	int alturaAgente = 10;
	int larguraMina = 10;
	int alturaMina = 10;
	int larguraObstaculo = 10;
	int alturaObstaculo = 10;
	int larguraCC = 30;
	int alturaCC = 30;

	ArrayList<Objeto> agentes;
	ArrayList<Objeto> minas;
	ArrayList<Objeto> obstaculos;
	Objeto controlCenter;

	JTextField txtSizeAgente;
	JTextField txtSizeMina;
	JTextField txtSizeObstaculo;
	JTextField txtSizeCC;

	JButton btnColocarAgente;
	JButton btnColocarMina;
	JButton btnColocarObstaculo;
	JButton btnColocarCC;

	JButton btnSetSizeAgenteProximos;
	JButton btnSetSizeAgenteAll;

	JButton btnSetSizeMinaProximos;
	JButton btnSetSizeMinaAll;

	JButton btnSetSizeObstaculoProximos;
	JButton btnSetSizeObstaculoAll;

	JButton btnSetSizeCC;

	JButton btnBuildXML;

	JButton btnDiscretizar;

	TipoObjeto objeto;

	public Gerador() {
		super("Gerador");
		super.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		this.posX = 300;
		this.posY = 50;

		this.agentes = new ArrayList<Objeto>();
		this.minas = new ArrayList<Objeto>();
		this.obstaculos = new ArrayList<Objeto>();

		this.addMouseListener(this);

		objeto = TipoObjeto.AGENTE;

		this.montaJanela();
	}

	private void montaJanela() {
		this.getContentPane().setLayout(null);
		this.txtSizeAgente = new JTextField();
		this.txtSizeAgente.setText((new Integer(this.alturaAgente)).toString());
		this.txtSizeAgente.setBounds(50, 50, 200, 20);
		this.getContentPane().add(this.txtSizeAgente);
		this.btnSetSizeAgenteProximos = new JButton("Set Proximos Agentes");
		this.btnSetSizeAgenteProximos.setBounds(50, 80, 200, 20);
		this.btnSetSizeAgenteProximos.addActionListener(this);
		this.getContentPane().add(this.btnSetSizeAgenteProximos);
		this.btnSetSizeAgenteAll = new JButton("Set Todos Agentes");
		this.btnSetSizeAgenteAll.setBounds(50, 110, 200, 20);
		this.btnSetSizeAgenteAll.addActionListener(this);
		this.getContentPane().add(this.btnSetSizeAgenteAll);
		this.btnColocarAgente = new JButton("Colocar Agentes");
		this.btnColocarAgente.setBounds(50, 140, 200, 20);
		this.btnColocarAgente.addActionListener(this);
		this.getContentPane().add(this.btnColocarAgente);

		this.txtSizeMina = new JTextField();
		this.txtSizeMina.setText((new Integer(this.alturaMina)).toString());
		this.txtSizeMina.setBounds(50, 190, 200, 20);
		this.getContentPane().add(this.txtSizeMina);
		this.btnSetSizeMinaProximos = new JButton("Set Proximas Minas");
		this.btnSetSizeMinaProximos.setBounds(50, 220, 200, 20);
		this.btnSetSizeMinaProximos.addActionListener(this);
		this.getContentPane().add(this.btnSetSizeMinaProximos);
		this.btnSetSizeMinaAll = new JButton("Set Todas Minas");
		this.btnSetSizeMinaAll.setBounds(50, 250, 200, 20);
		this.btnSetSizeMinaAll.addActionListener(this);
		this.getContentPane().add(this.btnSetSizeMinaAll);
		this.btnColocarMina = new JButton("Colocar Minas");
		this.btnColocarMina.setBounds(50, 280, 200, 20);
		this.btnColocarMina.addActionListener(this);
		this.getContentPane().add(this.btnColocarMina);

		this.txtSizeObstaculo = new JTextField();
		this.txtSizeObstaculo.setText((new Integer(this.alturaObstaculo))
				.toString());
		this.txtSizeObstaculo.setBounds(50, 330, 200, 20);
		this.getContentPane().add(this.txtSizeObstaculo);
		this.btnSetSizeObstaculoProximos = new JButton(
				"Set Proximos Obstaculos");
		this.btnSetSizeObstaculoProximos.setBounds(50, 360, 200, 20);
		this.btnSetSizeObstaculoProximos.addActionListener(this);
		this.getContentPane().add(this.btnSetSizeObstaculoProximos);
		this.btnSetSizeObstaculoAll = new JButton("Set Todos Obstaculos");
		this.btnSetSizeObstaculoAll.setBounds(50, 390, 200, 20);
		this.btnSetSizeObstaculoAll.addActionListener(this);
		this.getContentPane().add(this.btnSetSizeObstaculoAll);
		this.btnColocarObstaculo = new JButton("Colocar Obstaculos");
		this.btnColocarObstaculo.setBounds(50, 420, 200, 20);
		this.btnColocarObstaculo.addActionListener(this);
		this.getContentPane().add(this.btnColocarObstaculo);

		this.txtSizeCC = new JTextField();
		this.txtSizeCC.setText((new Integer(this.alturaCC)).toString());
		this.txtSizeCC.setBounds(50, 470, 200, 20);
		this.getContentPane().add(this.txtSizeCC);
		this.btnSetSizeCC = new JButton("Set CC");
		this.btnSetSizeCC.setBounds(50, 500, 200, 20);
		this.btnSetSizeCC.addActionListener(this);
		this.getContentPane().add(this.btnSetSizeCC);
		this.btnColocarCC = new JButton("Colocar CC");
		this.btnColocarCC.setBounds(50, 530, 200, 20);
		this.btnColocarCC.addActionListener(this);
		this.getContentPane().add(this.btnColocarCC);

		this.btnBuildXML = new JButton("Build XML");
		this.btnBuildXML.setBounds(50, 580, 200, 20);
		this.btnBuildXML.addActionListener(this);
		this.getContentPane().add(this.btnBuildXML);

		this.btnDiscretizar = new JButton("Discretizar");
		this.btnDiscretizar.setBounds(50, 630, 200, 20);
		this.btnDiscretizar.addActionListener(this);
		this.getContentPane().add(this.btnDiscretizar);

	}

	public void paint(Graphics g) {
		g.setColor(Color.BLACK);
		g.fillRect(300, 50, this.larguraQuadro, this.alturaQuadro);
		g.setColor(Color.BLUE);
		for (int i = 0; i < this.agentes.size(); i++) {
			g.fillOval((int) this.agentes.get(i).ponto.getX()
					- (this.agentes.get(i).largura / 2), (int) this.agentes
					.get(i).ponto.getY()
					- (this.agentes.get(i).altura / 2),
					this.agentes.get(i).largura, this.agentes.get(i).altura);
		}
		g.setColor(Color.YELLOW);
		for (int i = 0; i < this.minas.size(); i++) {
			g.fillOval((int) this.minas.get(i).ponto.getX()
					- (this.minas.get(i).largura / 2),
					(int) this.minas.get(i).ponto.getY()
							- (this.minas.get(i).altura / 2),
					this.minas.get(i).largura, this.minas.get(i).altura);
		}
		g.setColor(Color.GRAY);
		for (int i = 0; i < this.obstaculos.size(); i++) {
			g.fillOval((int) this.obstaculos.get(i).ponto.getX()
					- (this.obstaculos.get(i).largura / 2),
					(int) this.obstaculos.get(i).ponto.getY()
							- (this.obstaculos.get(i).altura / 2),
					this.obstaculos.get(i).largura,
					this.obstaculos.get(i).altura);
		}
		if (this.controlCenter != null) {
			g.setColor(Color.CYAN);
			g.fillOval((int) this.controlCenter.ponto.getX()
					- (this.controlCenter.largura / 2),
					(int) this.controlCenter.ponto.getY()
							- (this.controlCenter.altura / 2),
					this.controlCenter.largura, this.controlCenter.altura);
		}

	}

	public static void main(String[] args) {
		Gerador janela = new Gerador();
		janela.setSize(1000, 800);
		janela.setVisible(true);
	}

	public void actionPerformed(ActionEvent e) {
		if (e.getActionCommand().equals("Set Proximos Agentes")) {
			int size = new Integer(this.txtSizeAgente.getText());
			this.alturaAgente = size;
			this.larguraAgente = size;
		} else if (e.getActionCommand().equals("Set Todos Agentes")) {
			int size = (new Integer(this.txtSizeAgente.getText())).intValue();
			this.alturaAgente = size;
			this.larguraAgente = size;
			for (int i = 0; i < this.agentes.size(); i++) {
				this.agentes.get(i).altura = this.alturaAgente;
				this.agentes.get(i).largura = this.larguraAgente;
			}
		} else if (e.getActionCommand().equals("Colocar Agentes")) {
			this.objeto = TipoObjeto.AGENTE;
		} else if (e.getActionCommand().equals("Set Proximas Minas")) {
			int size = new Integer(this.txtSizeMina.getText());
			this.alturaMina = size;
			this.larguraMina = size;
		} else if (e.getActionCommand().equals("Set Todas Minas")) {
			int size = (new Integer(this.txtSizeMina.getText())).intValue();
			this.alturaMina = size;
			this.larguraMina = size;
			for (int i = 0; i < this.minas.size(); i++) {
				this.minas.get(i).altura = this.alturaMina;
				this.minas.get(i).largura = this.larguraMina;
			}
		} else if (e.getActionCommand().equals("Colocar Minas")) {
			this.objeto = TipoObjeto.MINA;
		} else if (e.getActionCommand().equals("Set Proximos Obstaculos")) {
			int size = new Integer(this.txtSizeObstaculo.getText());
			this.alturaObstaculo = size;
			this.larguraObstaculo = size;
		} else if (e.getActionCommand().equals("Set Todos Obstaculos")) {
			int size = (new Integer(this.txtSizeObstaculo.getText()))
					.intValue();
			this.alturaObstaculo = size;
			this.larguraObstaculo = size;
			for (int i = 0; i < this.obstaculos.size(); i++) {
				this.obstaculos.get(i).altura = this.alturaObstaculo;
				this.obstaculos.get(i).largura = this.larguraObstaculo;
			}
		} else if (e.getActionCommand().equals("Colocar Obstaculos")) {
			this.objeto = TipoObjeto.OBSTACULO;
		} else if (e.getActionCommand().equals("Set CC")) {
			int size = new Integer(this.txtSizeCC.getText());
			this.alturaCC = size;
			this.larguraCC = size;
			if (this.controlCenter != null) {
				this.controlCenter.altura = this.alturaCC;
				this.controlCenter.largura = this.larguraCC;
			}
		} else if (e.getActionCommand().equals("Colocar CC")) {
			this.objeto = TipoObjeto.CONTROL_CENTER;
		} else if (e.getActionCommand().equals("Discretizar")) {
			for (int i = 0; i < this.agentes.size(); i++) {
				this.agentes.get(i).ponto.x = this.agentes.get(i).ponto.x - (this.agentes.get(i).ponto.x%this.larguraAgente);
				this.agentes.get(i).ponto.y = this.agentes.get(i).ponto.y - (this.agentes.get(i).ponto.y%this.alturaAgente);
			}
			for (int i = 0; i < this.minas.size(); i++) {
				this.minas.get(i).ponto.x = this.minas.get(i).ponto.x - (this.minas.get(i).ponto.x%this.larguraMina);
				this.minas.get(i).ponto.y = this.minas.get(i).ponto.y - (this.minas.get(i).ponto.y%this.alturaMina);
			}
			for (int i = 0; i < this.obstaculos.size(); i++) {
				this.obstaculos.get(i).ponto.x = this.obstaculos.get(i).ponto.x - (this.obstaculos.get(i).ponto.x%this.larguraObstaculo);
				this.obstaculos.get(i).ponto.y = this.obstaculos.get(i).ponto.y - (this.obstaculos.get(i).ponto.y%this.alturaObstaculo);
			}
			if(this.controlCenter != null){
				this.controlCenter.ponto.x = this.controlCenter.ponto.x - (this.controlCenter.ponto.x%this.alturaAgente);
				this.controlCenter.ponto.y = this.controlCenter.ponto.y - (this.controlCenter.ponto.y%this.larguraAgente);
			}
			this.repaint();
		} else if (e.getActionCommand().equals("Build XML")) {
			System.out.println("<map>");
			System.out.println("\t<name>Map1</name>");
			System.out.println(String.format("\t<width>%d</width>",
					this.larguraQuadro));
			System.out.println(String.format("\t<height>%d</height>",
					this.alturaQuadro));
			System.out.println("\t<buildings>");
			if(this.controlCenter != null){
				System.out.println("\t\t<building>");
				System.out.println("\t\t\t<team>Team 1</team>");
				System.out.println("\t\t\t<name>Control Center</name>");
				System.out.println(String.format("\t\t\t<x>%d</x>",
						this.controlCenter.ponto.x - 300));
				System.out.println(String.format("\t\t\t<y>%d</y>",
						this.controlCenter.ponto.y - 50));
				System.out.println(String.format("\t\t\t<width>%d</width>",
						this.controlCenter.largura));
				System.out.println(String.format("\t\t\t<height>%d</height>",
						this.controlCenter.altura));
				System.out.println("\t\t</building>");
			}
			System.out.println("\t</buildings>");
			System.out.println("\t<units>");

			for (int i = 0; i < this.agentes.size(); i++) {
				System.out.println("\t\t<unit>");
				System.out.println("\t\t\t<team>Team 1</team>");
				System.out.println("\t\t\t<name>Worker</name>");
				System.out.println(String.format("\t\t\t<x>%d</x>",
						this.agentes.get(i).ponto.x - 300));
				System.out.println(String.format("\t\t\t<y>%d</y>",
						this.agentes.get(i).ponto.y - 50));
				System.out.println(String.format("\t\t\t<width>%d</width>",
						this.agentes.get(i).largura));
				System.out.println(String.format("\t\t\t<height>%d</height>",
						this.agentes.get(i).altura));
				System.out.println("\t\t</unit>");
			}

			System.out.println("\t</units>");
			System.out.println("\t<resources>");

			for (int i = 0; i < this.minas.size(); i++) {
				System.out.println("\t\t<resource>");
				System.out.println("\t\t\t<name>Mine</name>");
				System.out.println(String.format("\t\t\t<x>%d</x>", this.minas
						.get(i).ponto.x - 300));
				System.out.println(String.format("\t\t\t<y>%d</y>", this.minas
						.get(i).ponto.y - 50));
				System.out.println(String.format("\t\t\t<width>%d</width>",
						this.minas.get(i).largura));
				System.out.println(String.format("\t\t\t<height>%d</height>",
						this.minas.get(i).altura));
				System.out.println("\t\t</resource>");
			}

			System.out.println("\t</resources>");
			System.out.println("\t<obstacles>");

			for (int i = 0; i < this.obstaculos.size(); i++) {
				System.out.println("\t\t<obstacle>");
				System.out.println("\t\t\t<name>Obstacle</name>");
				System.out.println(String.format("\t\t\t<x>%d</x>",
						this.obstaculos.get(i).ponto.x - 300));
				System.out.println(String.format("\t\t\t<y>%d</y>",
						this.obstaculos.get(i).ponto.y - 50));
				System.out.println(String.format("\t\t\t<width>%d</width>",
						this.obstaculos.get(i).largura));
				System.out.println(String.format("\t\t\t<height>%d</height>",
						this.obstaculos.get(i).altura));
				System.out.println("\t\t</obstacle>");
			}

			System.out.println("\t</obstacles>");
			System.out.println("</map>");
		}
		this.repaint();
	}

	public void mouseClicked(MouseEvent e) {
	}

	public void mouseEntered(MouseEvent e) {
	}

	public void mouseExited(MouseEvent e) {
	}

	public void mousePressed(MouseEvent e) {
		if ((e.getPoint().getX() > (300 + this.larguraAgente))
				&& (e.getPoint().getY() > 50 + this.alturaAgente)
				&& (e.getPoint().getX() < (300 + this.larguraQuadro - this.larguraAgente))
				&& (e.getPoint().getY() < (50 + this.alturaQuadro - this.alturaAgente))) {
			if (objeto == TipoObjeto.AGENTE) {
				this.agentes.add(new Objeto(e.getPoint(), this.larguraAgente,
						this.alturaAgente));
			} else if (objeto == TipoObjeto.MINA) {
				this.minas.add(new Objeto(e.getPoint(), this.larguraMina,
						this.alturaMina));
			} else if (objeto == TipoObjeto.OBSTACULO) {
				this.obstaculos.add(new Objeto(e.getPoint(),
						this.larguraObstaculo, this.alturaObstaculo));
			} else if (objeto == TipoObjeto.CONTROL_CENTER) {
				this.controlCenter = new Objeto(e.getPoint(), this.larguraCC,
						this.alturaCC);
			}
			this.repaint();
		}
	}

	public void mouseReleased(MouseEvent e) {
	}

	class Objeto {
		Point ponto;
		int largura;
		int altura;

		public Objeto(Point ponto, int largura, int altura) {
			this.ponto = ponto;
			this.largura = largura;
			this.altura = altura;
		}
	}

	enum TipoObjeto {
		AGENTE, MINA, OBSTACULO, CONTROL_CENTER
	}

}
